package org.proxy;

import org.json.simple.JSONObject;
import org.json.simple.parser.JSONParser;
import org.json.simple.parser.ParseException;

import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.List;

import static org.dhaverdLogs.DhaverdLogs.setLog;

public class loadConfig {

    public static JSONObject getJsonObjConfig() throws IOException, ParseException {
        File config = getConfigFile();
        FileReader reader = new FileReader(config);
        Object obj = new JSONParser().parse(reader);
        JSONObject jo = (JSONObject) obj;
        reader.close();
        return jo;
    }

    public static File getConfigFile() throws IOException {
        File config = new File("config/config.json");
        if (config.exists()) {
            return config;
        } else {
            createConfig(config);
            config = new File("config/config.json");
            return config;
        }
    }

    public static void createConfig(File config) throws IOException {
        String[] props = {
                "{",
                "\t\"port\" : \"7458\"",
                "}"
        };
        FileWriter writer = new FileWriter(config, true);
        for (int i = 0; i < props.length; i++){
            writer.write(props[i]+"\n");
        }
        writer.close();
    }

    public static int getSocketPort() throws IOException, ParseException {
        JSONObject jo = getJsonObjConfig();
        String result = String.valueOf(jo.get("port"));
        setLog("Config Loading", "Port loaded: " + result, true, false);
        return Integer.parseInt(result);
    }

    public static List<String> getProxyList() throws IOException, ParseException {
        JSONObject jo = getJsonObjConfig();
        List<String> result = (List<String>) jo.get("proxyList");
        setLog("Config Loading", "Proxy list loaded. Items count: " + result.size(), true, false);
        for (String line : result) {
            setLog("Config Loading", "Proxy list item: " + line, false, true);
        }
        return result;
    }

}
